(* Equality functions *)

value prefix = : 'a -> 'a -> bool = 2 "tree_equal"
        (* "e1 = e2" tests for structural equality of e1 and e2.
           Mutable structures (e.g. references) are equal even if
           they are not the same physical object, but their
           current contents are structurally equal.
           Equality between functional values returns meaningless results.
           Equality between cyclic data structures may not terminate. *)
  and prefix <> : 'a -> 'a -> bool
        (* Negation of prefix = *)
  and prefix == : 'a -> 'a -> bool = 2 "=="
        (* "e1 == e2" tests for physical equality of e1 and e2
           (pointer equality). *)
  and prefix != : 'a -> 'a -> bool = 2 "!="
        (* Negation of prefix == *)
;;
