(* Exceptions *)

value raise : exn -> 'a = 1 "raise";;
        (* Raises the given exception value. *)

(* A few general-purpose predefined exceptions. *)

exception failure of string;;
        (* Raised by some library functions, to signal that they are
           undefined on the given arguments. *)
exception Invalid_argument of string;;
        (* Raised by some library functions, to signal that the given
           arguments do not make sense. *)
exception Out_of_memory;;
        (* Raised by the garbage collector, when there is insufficient
           memory to complete the computation. *)

value failwith : string -> 'a;;
        (* Raises exception failure with the given string. *)
value invalid_arg : string -> 'a;;
        (* Raises exception Invalid_argument with the given string. *)


