(* Operations on pairs *)

value fst : 'a * 'b -> 'a = 1 "field0"
        (* Returns the first component of a pair *)
  and snd : 'a * 'b -> 'b = 1 "field1"
        (* Returns the second component of a pair *)
  and split : ('a * 'b) list -> 'a list * 'b list
        (* Transforms a list of pairs into a pair of lists:
             split [(a1,b1); ...; (an,bn)] = [a1; ...; an], [b1; ...; bn] *)
  and combine : 'a list * 'b list -> ('a * 'b) list
        (* Transforms a pair of lists into a list of pairs:
             combine ([a1; ...; an], [b1; ...; bn]) =
               [(a1,b1); ...; (an,bn)].
           Raises failure "combine" if the two lists have different lengths. *)
  and map2 : ('a -> 'b -> 'c) -> 'a list -> 'b list -> 'c list
        (* map2 f [a1; ...; an] [b1; ...; bn] = [f a1 b1; ...; f an bn] *)
  and map2_uncurry : ('a * 'b -> 'c) -> 'a list * 'b list -> 'c list
        (* map2_uncurry f [a1; ...; an] [b1; ...; bn] =
               [f (a1, b1); ...; f (an, bn)] *)
  and do_list2 : ('a -> 'b -> 'c) -> 'a list -> 'b list -> unit
        (* do_list2 f [a1; ...; an] [b1; ...; bn] performs
               f a1 b1; ...; f an bn *)
  and do_list2_uncurry : ('a * 'b -> 'c) -> 'a list * 'b list -> unit
        (* do_list2_uncurry f [a1; ...; an] [b1; ...; bn] performs
               f (a1, b1); ...; f (an, bn) *)
  and it_list2 : ('a -> 'b -> 'c -> 'a) -> 'a -> 'b list -> 'c list -> 'a
        (* it_list2 f a [b1; ...; bn] [c1; ...; cn] =
               f (... (f (f a b1 c1) b2 c2) ...) bn cn  *)
  and list_it2 : ('a -> 'b -> 'c -> 'c) -> 'a list -> 'b list -> 'c -> 'c
        (* list_it2 f [a1; ...; an] [b1; ...; bn] c =
               f a1 b1 (f a2 b2 (... (f an bn c) ...)) *)
;;
